<?php

if(!defined('OT_ROOT')) {
	exit('Access Denied');
}



class AdmTpl{

	// 登录页面
	public static function LoginWeb(){
		global $sysAdminArr;

		switch ($sysAdminArr['SA_tplDir']){
			case 'youyou/':
				return AdmTplYouyou::LoginWeb();
				break;
		
			default :
				return AdmTplDef::LoginWeb();
				break;
		}
	}

	// 首页页面
	public static function IndexWeb(){
		global $sysAdminArr;

		switch ($sysAdminArr['SA_tplDir']){
			case 'youyou/':
				return AdmTplYouyou::IndexWeb();
				break;
		
			default :
				return AdmTplDef::IndexWeb();
				break;
		}
	}


	// 通用配置文件
	public static function WebConfig(){
		global $sysAdminArr;

		switch ($sysAdminArr['SA_tplDir']){
			case 'youyou/':
				return AdmTplYouyou::WebConfig();
				break;
		
			default :
				return AdmTplDef::WebConfig();
				break;
		}
	}

	// 表格页头
	public static function TableTop($img, $IDname, $CNname){
		global $sysAdminArr;

		switch ($sysAdminArr['SA_tplDir']){
			case 'youyou/':
				return AdmTplYouyou::TableTop($img, $IDname, $CNname);
				break;
		
			default :
				return AdmTplDef::TableTop($img, $IDname, $CNname);
				break;
		}
	}

	// 表格页头2
	public static function TableTop2($img, $IDname, $CNname){
		global $sysAdminArr;

		switch ($sysAdminArr['SA_tplDir']){
			case 'youyou/':
				return AdmTplYouyou::TableTop2($img, $IDname, $CNname);
				break;
		
			default :
				return AdmTplDef::TableTop2($img, $IDname, $CNname);
				break;
		}
	}

	// 主菜单
	public static function MenuStr($CNname, $ENname, $styleStr='', $judGet=true){
		global $sysAdminArr;

		switch ($sysAdminArr['SA_tplDir']){
			case 'youyou/':
				return AdmTplYouyou::MenuStr($CNname, $ENname, $styleStr, $judGet);
				break;
		
			default :
				return AdmTplDef::MenuStr($CNname, $ENname, $styleStr, $judGet);
				break;
		}
	}

	// 子菜单
	public static function MenuStr2($menuSelID, $menuID, $menuName, $URL, $styleStr=''){
		global $sysAdminArr;

		switch ($sysAdminArr['SA_tplDir']){
			case 'youyou/':
				return AdmTplYouyou::MenuStr2($menuSelID, $menuID, $menuName, $URL, $styleStr);
				break;
		
			default :
				return AdmTplDef::MenuStr2($menuSelID, $menuID, $menuName, $URL, $styleStr);
				break;
		}
	}

	// 登陆页验证码
	public static function ShowVerCode($svcForm,$svcId=''){
		global $sysAdminArr;

		switch ($sysAdminArr['SA_tplDir']){
			case 'youyou/':
				return AdmTplYouyou::ShowVerCode($svcForm,$svcId);
				break;
		
			default :
				return AdmTplDef::ShowVerCode($svcForm,$svcId);
				break;
		}
	}

	// 左侧子菜单列表
	public static function LeftMenu(){
		global $DB,$MB,$autoOpenStr;

		$autoOpenStr='';
		$menuSelID	= 'revSelf';
		$retStr = '
		<div id="leftMenuID'. $menuSelID .'" style="display:none;">
			'. self::MenuStr2($menuSelID,'修改用户名或密码','修改用户名或密码','admin.php?mudi=revPwd') .'
			'. self::MenuStr2($menuSelID,'其他信息设置','其他信息设置','admin.php?mudi=revOthers') .'
			';

		$autoOpenStr='';
		$menuSelID	= 'user';
		$retStr .= '
		</div>
		<div id="leftMenuID'. $menuSelID .'" style="display:none;">
			'. AppBase::LeftMenuBox1($menuSelID) .'
			'. self::MenuStr2($menuSelID,'用户管理','用户管理','member.php?mudi=manage') .'
			';

		$autoOpenStr='';
		$menuSelID	= 'database';
		$retStr .= '
		</div>
		<div id="leftMenuID'. $menuSelID .'" style="display:none;">';
			if (AreaApp::Jud(161)){
				$retStr .=  self::MenuStr2($menuSelID,999920,'多网站登录','siteLogin.php?mudi=manage');
			}
			if (OT_Database=='sqlite'){
				$retStr .= self::MenuStr2($menuSelID,999901,'数据库备份/压缩','dbBak.php?mudi=manage');
			}elseif (OT_Database=='mysql'){
				$retStr .= 
					self::MenuStr2($menuSelID,999902,'数据库备份','dbBakMySQL.php?mudi=backup') .
					self::MenuStr2($menuSelID,999903,'数据库恢复','dbBakMySQL.php?mudi=restore');
			//	MenuStr2($menuSelID,999904,'数据表优化','dbBakMySQL.php?mudi=table');
			}
			$retStr .= 
				self::MenuStr2($menuSelID,999905,'程序文件备份','softBak.php?mudi=backup') .
				self::MenuStr2($menuSelID,999906,'程序/数据库备份','softBak.php?mudi=manage') .
				self::MenuStr2($menuSelID,999907,'后台参数配置','sysAdmin.php?mudi=manage') .
				self::MenuStr2($menuSelID,999908,'程序文件检查','sysCheckFile.php?mudi=manage') .
				self::MenuStr2($menuSelID,999909,'数据处理管理','dataDeal.php?mudi=manage&dataType=news&dataTypeCN='. urlencode('数据处理')) .
				self::MenuStr2($menuSelID,999910,'后台菜单排序','adminMenu.php?mudi=manage') .
				self::MenuStr2($menuSelID,999911,'自定义静态页','makeDiy.php?mudi=manage&dataTypeCN='. urlencode('自定义静态页') .'') .
				self::MenuStr2($menuSelID,999912,'上传文件管理','serverFile.php?mudi=manage') .
				self::MenuStr2($menuSelID,999913,'后台操作日志','memberLog.php?mudi=manage') .
				self::MenuStr2($menuSelID,999914,'后台在线记录','memberOnline.php?mudi=manage') .
				self::MenuStr2($menuSelID,999915,'在线升级记录','update.php?mudi=manage') .
				self::MenuStr2($menuSelID,999916,'数据库错误日志','dbErr.php?mudi=manage') .
				self::MenuStr2($menuSelID,999917,'特定文档查看','editFile.php?mudi=manage') .
				self::MenuStr2($menuSelID,999919,'API调用日志','apiRecord.php?mudi=manage');

			$menuSelID=0;
			$payArr = AdmArea::GetAppIdArr();	// 获取已购买插件appID数组
			$menuexe=$DB->query('select MT_ID,MT_theme,MT_themeStyle,MT_URL,MT_menuID from '. OT_dbPref .'menuTree where MT_level=1 and MT_userState=1 and MT_state=1 and MT_appID in ('. implode(',',$payArr) .') order by MT_menuID ASC,MT_rank ASC');
				while ($row = $menuexe->fetch()){
					if ($menuSelID != $row['MT_menuID']){
						$menuSelID = $row['MT_menuID'];
						
						$autoOpenStr='';
						$retStr .= '</div><div id="leftMenuID'. $menuSelID .'" style="display:none;">';
					}
					$retStr .= self::MenuStr2($menuSelID,$row['MT_ID'],$row['MT_theme'],$row['MT_URL'],$row['MT_themeStyle']);
				}
			unset($menuexe);
		$retStr .= '
		</div>
		';

		return $retStr;
	}

	// 图片加载
	public static function ImgSrc($imgName){
		global $sysAdminArr;

		switch ($sysAdminArr['SA_tplDir']){
			case 'youyou/':
				return 'template/youyou/images/'. $imgName .'.gif';
				break;
		
			default :
				return 'template/default/images/'. $imgName .'.gif';
				break;
		}
	}

}